'subtotal' is incorrect in API responses
Status: Closed   

Priority: High   

Assignee: John Mitsch   

Category: API   

Target version: 1.20.1   

Difficulty:  Fixed in Releases: 1.20.1, 1.21.0

Triaged: No Found in Releases: 1.18.2, 1.19.0

Bugzilla link: 1642549 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/6254,

https://github.com/theforeman/foreman/p

ull/6299

  

Description

When requesting an endpoint with a search parameter, the subtotal shows the results returned, rather than responses found.

i.e.

curl -k -u admin:changeme -H "Content-Type: application/json"

'localhost:3000/api/v2/hosts?search=%20os_major%20%3D%20%207'

{

"total": 72,

"subtotal": 20,

"page": 1,

"per_page": 20,

"search": " os_major =  7",

"sort": {

"by": null,

"order": null

},

...

The subtotal is 20, which is the results returned and not the actual number of results returned by the search query.

Related issues:

Related to Foreman - Bug #24712: Foreman (1.18?) slow API call against fact_v... Closed

Associated revisions

Revision 660e9794 - 12/03/2018 05:15 PM - John Mitsch

Fixes #25487 - Fix subtotal in API response

When requesting an endpoint with a search parameter, the subtotal

shows the results returned, rather than responses found. i.e. even

if 200 results were found, if 20 are being returned because of

pagination, the subtotal will be 20.

This changes back to using `count`, which sends another SQL query

and returns the correct subtotal.

History

#1 - 11/16/2018 04:44 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/6254 added

#2 - 11/18/2018 10:24 AM - Tomer Brisker
- Found in Releases 1.18.2, 1.19.0 added

#3 - 11/18/2018 10:25 AM - Tomer Brisker

- Related to Bug #24712: Foreman (1.18?) slow API call against fact_values endpoint added

#4 - 12/03/2018 03:32 PM - Tomer Brisker

- Target version set to 1.20.1

#5 - 12/03/2018 05:20 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/6299 added

#6 - 12/03/2018 06:01 PM - John Mitsch

- Status changed from Ready For Testing to Closed

Applied in changeset 660e9794af46b3f614b54fe0f2c9375a169f3613.

#7 - 12/04/2018 06:58 AM - Marek Hulán

- Fixed in Releases 1.20.1 added

#8 - 12/04/2018 07:09 AM - Tomer Brisker

- Fixed in Releases 1.21.0 added

#9 - 12/06/2018 02:04 PM - John Mitsch

- Bugzilla link set to 1642549
